#Camels
execute as @e[type=minecraft:villager] at @s if entity @e[type=camel,nbt={SaddleItem:{id:"minecraft:saddle",Count:1b}},distance=..1,tag=!occupied,sort=nearest] run ride @s mount @e[type=camel,nbt={SaddleItem:{id:"minecraft:saddle",Count:1b}},tag=!occupied,sort=nearest,limit=1]
execute as @e[type=minecraft:villager] on vehicle at @e[type=camel,nbt={SaddleItem:{id:"minecraft:saddle",Count:1b}},tag=!occupied] run tag @s add occupied
execute as @e[type=camel,nbt={SaddleItem:{id:"minecraft:saddle",Count:1b}}] if predicate travel:mount run tag @s remove occupied
execute as @e[type=camel,nbt={SaddleItem:{id:"minecraft:saddle",Count:1b}}] on passengers run tag @s add camel_riden

#Dismount Camels
execute as @e[type=villager] if predicate travel:dismount run tag @s remove camel_riden
execute as @p[advancements={travel:travel/camel_riden=true}] at @s positioned ^ ^ ^4 if entity @e[type=minecraft:villager,distance=1..4,tag=camel_riden,sort=nearest] run ride @e[type=minecraft:villager,tag=camel_riden,limit=1,sort=nearest] dismount
execute as @p[advancements={travel:travel/camel_riden=true}] at @s positioned ^ ^ ^4 if entity @e[type=minecraft:villager,distance=1..4,tag=camel_riden,sort=nearest] run tp @e[type=minecraft:villager,tag=camel_riden,limit=1,sort=nearest] @p
execute as @p[advancements={travel:travel/camel_riden=true}] run advancement revoke @s only travel:travel/camel_riden

#Boats & Minecarts
execute as @e[type=minecraft:villager] at @s if entity @e[type=#travel:villager_rideable,distance=..1,tag=!occupied,sort=nearest] run ride @s mount @e[type=#travel:villager_rideable,tag=!occupied,sort=nearest,limit=1]
execute as @e[type=minecraft:villager] on vehicle at @e[type=#travel:villager_rideable,tag=!occupied] run tag @s add occupied
execute as @e[type=#travel:villager_rideable] if predicate travel:mount run tag @s remove occupied
execute as @e[type=#travel:villager_rideable] on passengers run tag @s add riden

#Dismount Boats & Minecarts
execute as @e[type=villager] if predicate travel:dismount run tag @s remove riden
execute as @p[advancements={travel:travel/riden=true}] at @s positioned ^ ^ ^4 if entity @e[type=minecraft:villager,distance=1..4,tag=riden,sort=nearest] run ride @e[type=minecraft:villager,tag=riden,limit=1,sort=nearest] dismount
execute as @p[advancements={travel:travel/riden=true}] at @s positioned ^ ^ ^4 if entity @e[type=minecraft:villager,distance=1..4,tag=riden,sort=nearest] run tp @e[type=minecraft:villager,tag=riden,limit=1,sort=nearest] @p
execute as @p[advancements={travel:travel/riden=true}] run advancement revoke @s only travel:travel/riden

#Llamas
execute as @e[type=minecraft:villager] at @s if entity @e[type=trader_llama,nbt={Tame:1b},distance=..1,tag=!occupied,sort=nearest] run ride @s mount @e[type=trader_llama,nbt={Tame:1b},tag=!occupied,sort=nearest,limit=1]
execute as @e[type=minecraft:villager] on vehicle at @e[type=trader_llama,nbt={Tame:1b},tag=!occupied] run tag @s add occupied
execute as @e[type=trader_llama,nbt={Tame:1b}] if predicate travel:mount run tag @s remove occupied
execute as @e[type=trader_llama,nbt={Tame:1b}] on passengers run tag @s add llama_riden

#Dismount Llamas
execute as @e[type=villager] if predicate travel:dismount run tag @s remove llama_riden
execute as @p[advancements={travel:travel/llama_riden=true}] at @s positioned ^ ^ ^4 if entity @e[type=minecraft:villager,distance=1..4,tag=llama_riden,sort=nearest] run ride @e[type=minecraft:villager,tag=llama_riden,limit=1,sort=nearest] dismount
execute as @p[advancements={travel:travel/llama_riden=true}] at @s positioned ^ ^ ^4 if entity @e[type=minecraft:villager,distance=1..4,tag=llama_riden,sort=nearest] run tp @e[type=minecraft:villager,tag=llama_riden,limit=1,sort=nearest] @p
execute as @p[advancements={travel:travel/llama_riden=true}] run advancement revoke @s only travel:travel/llama_riden

#Llama Speed
execute as @e[type=#travel:llamas,tag=occupied,nbt={Leash:{}}] run attribute @s generic.movement_speed base set 0.185
execute as @e[type=#travel:llamas,tag=occupied,nbt=!{Leash:{}}] run attribute @s generic.movement_speed base set 0.235
execute as @e[type=#travel:llamas,tag=!occupied,nbt=!{Leash:{}}] run attribute @s generic.movement_speed base set 0.175
execute if entity @e[type=#travel:llamas] run function travel:llamas